NNG_STREAM_RECV(3str)

NAME
nng_stream_recv - receive from byte stream

SYNOPSIS

    #include <nng/nng.h>
    void nng_stream_recv(nng_stream *s, nng_aio *aio);

DESCRIPTION

The nng_stream_recv() function starts an asynchronous receive from the byte stream s into the scatter/gather vector located in the asynchronous I/O structure aio.

    Note

    The nng_aio_set_iov() function must have been called first, to set the scatter/gather vector for aio.

This function returns immediately, with no return value. Completion of the operation is signaled via the aio, and the final result may be obtained via nng_aio_result(). That result will either be zero or an error code.

The I/O operation completes as soon as at least one byte has been received, or an error has occurred. Therefore, the number of bytes read may be less than requested. The actual number of bytes read can be determined with nng_aio_count().

RETURN VALUES

None.

ERRORS

NNG_ECANCELED
    The operation was canceled.

NNG_ECLOSED
    The connection was closed.

NNG_ECONNRESET
    The peer closed the connection.

NNG_ECONNSHUT
    Remote peer shutdown after sending data.

NNG_EINVAL
    The aio does not contain a valid scatter/gather vector.

NNG_ENOMEM
    Insufficient free memory to perform the operation.

NNG_ETIMEDOUT
    Timeout waiting for data from the connection.

SEE ALSO

nng_aio_alloc(3), nng_aio_count(3), nng_aio_result(3), nng_aio_set_iov(3), nng_strerror(3), nng_stream_close(3str), nng_stream_send(3str), nng_stream(5)